/*

	mmr.h - MMR routines used by the Power JBIG-2 Decoder / Encoder


	Author:
		Dave Tompkins (dave.tompkins@ieee.org)
		University of British Columbia

	Source:
		http://spmg.ece.ubc.ca/jbig2
	  
	Revision History:

		1.0.0	1999-03-15	First Release


	Copyright:
		(c) 1998 University of British Columbia and Image Power, Inc.

		The program may be used for academic, demonstration and research 
		purposes only.  It may not be sold for profit or incorporated into
		any commercial programs and/or services without first obtaining a
		commercial useage license from Image Power, Inc.  This program is
		provided as is, without any express or implied warranty, including
		the warranty of fitness for a particular purpose or warranties of
		merchantability.

*/


#ifndef MMR_H

#define MMR_H

#include "jb2structs.h"

/* Encoding & Decoding terms are defined here for portability */
void EncodeBits(ENCODER *, ULONG, ULONG);
void EncodeFlush(ENCODER *);
ULONG DecodeHuffTree (DECODER *, HUFFNODE *);
void DecodeFlush(DECODER *);

void MMREncode(ENCODER *, BMP *,BOOLN);
void MMRDecode(DECODER *, MMRTABLES *, BMP *,BOOLN);

void InitializeMMR(MMRTABLES *);
void FreeMMR(MMRTABLES *);

#endif

