/*

	mqcoder.h - MQ routines used by the Power JBIG-2 Decoder / Encoder


	Author:
		Dave Tompkins (dave.tompkins@ieee.org)
		University of British Columbia

	Source:
		http://spmg.ece.ubc.ca/jbig2
	  
	Revision History:

		1.0.0	1999-03-15	First Release


	Copyright:
		(c) 1998 University of British Columbia and Image Power, Inc.

		The program may be used for academic, demonstration and research 
		purposes only.  It may not be sold for profit or incorporated into
		any commercial programs and/or services without first obtaining a
		commercial useage license from Image Power, Inc.  This program is
		provided as is, without any express or implied warranty, including
		the warranty of fitness for a particular purpose or warranties of
		merchantability.

*/


#ifndef MQCODER_H

#define MQCODER_H

#include "jb2types.h"

typedef struct tagMQBUFFER {
	BYTE *Index;
	BYTE *MPS;
} MQBUFFER;

typedef struct tagMQDEC
{
	ULONG C;
	ULONG A;
	ULONG CT;
	BYTE inBuffer;
	BOOLN bEOF;
	void *pDecoder;
	BYTE (*fByteIn)(void *);
} MQDEC;

typedef struct tagMQENC
{

	ULONG C;
	ULONG A;
	ULONG CT;

	BYTE outBuffer;
	BOOLN bFirstByte;
	BOOLN bLastByte;
	ULONG nFF;
	ULONG n7F;

	ULONG lNumBytesOut;
	
	void *pEncoder;
	void (*fByteOut)(void *, BYTE);
} MQENC;

void MQSetOutFunction(MQENC *, void (*f)(void *, BYTE), void *);
void MQInitEnc(MQENC *);
void MQEncode(MQENC *, BOOLN,BYTE *,BYTE *);
void MQEncodeStats(MQENC *, BOOLN,BYTE *,BYTE *, double *);
ULONG MQFlush(MQENC *);

void MQSetInFunction(MQDEC *, BYTE (*f)(void *), void *);
void MQInitDec(MQDEC *);
BOOLN MQDecode(MQDEC *, BYTE *, BYTE *);

#endif

