/*

	mqcontext.h - MQ Context routines used by the Power JBIG-2 Decoder / Encoder


	Author:
		Dave Tompkins (dave.tompkins@ieee.org)
		University of British Columbia

	Source:
		http://spmg.ece.ubc.ca/jbig2
	  
	Revision History:

		1.0.0	1999-03-15	First Release


	Copyright:
		(c) 1998 University of British Columbia and Image Power, Inc.

		The program may be used for academic, demonstration and research 
		purposes only.  It may not be sold for profit or incorporated into
		any commercial programs and/or services without first obtaining a
		commercial useage license from Image Power, Inc.  This program is
		provided as is, without any express or implied warranty, including
		the warranty of fitness for a particular purpose or warranties of
		merchantability.

*/


#ifndef MQCONTEXT_H

#define MQCONTEXT_H

#include "bmp.h"

#define MAXCONTEXTLINE 10
#define BUFFLEN 32
#define BUFFMASK 0xFFFFFFFF

typedef struct tagCONTEXTLINE {
	BMP *img;
	BYTE *pnext;
	BOOLN bEOL;
	SLONG nextxbyte;
	SLONG nexty;
	SLONG deltax;
	ULONG Buff;
	ULONG Mask;
	ULONG Shift;
	ULONG Count;
} CONTEXTLINE;

typedef struct tagCONTEXTATLINE {
	BMP *img;
	SLONG DeltaX;
	SLONG NextX;
	SLONG NextY;
	ULONG Shift;
} CONTEXTATLINE;

typedef struct tagMQCONTEXT {
	CONTEXTLINE lin[MAXCONTEXTLINE];
	CONTEXTATLINE ATlin[MAXCONTEXTLINE];

	ULONG numLines;
	ULONG numATLines;
	ULONG CurLineBuff;
	ULONG CurLineMask;
} MQCONTEXT;

void InitContext(MQCONTEXT *, BMP *,ULONG, SLONG *, SLONG *);
void NextContextRow(MQCONTEXT *);
ULONG GetContext(MQCONTEXT *,BOOLN);
void InitRefContext(MQCONTEXT *, BMP *source,BMP *dest, SLONG ox, SLONG oy, ULONG TEMPLATE, SLONG *, SLONG *);

#endif

