/*

	mqint.h - MQ Integer routines used by the Power JBIG-2 Decoder / Encoder


	Author:
		Dave Tompkins (dave.tompkins@ieee.org)
		University of British Columbia

	Source:
		http://spmg.ece.ubc.ca/jbig2
	  
	Revision History:

		1.0.0	1999-03-15	First Release


	Copyright:
		(c) 1998 University of British Columbia and Image Power, Inc.

		The program may be used for academic, demonstration and research 
		purposes only.  It may not be sold for profit or incorporated into
		any commercial programs and/or services without first obtaining a
		commercial useage license from Image Power, Inc.  This program is
		provided as is, without any express or implied warranty, including
		the warranty of fitness for a particular purpose or warranties of
		merchantability.

*/


#include "jb2types.h"
#include "mqcoder.h"

#ifndef MQINT_H

#define MQINT_H

/* THE MQINTSTRUCT contains the MQ context buffers, and determines if it is an
IAID (special case */

typedef struct tagMQINTSTRUCT {
	MQBUFFER Buffer;
	ULONG iContext;
	BOOLN bIAID;
	ULONG SBSYMCODELEN;
	MQDEC *pMQDec;
	MQENC *pMQEnc;
} MQINTSTRUCT;


void MQEncodeOOB(MQINTSTRUCT *inCoder);
void MQEncodeInt(MQINTSTRUCT *inCoder, SLONG Val);
SLONG MQDecodeInt(MQINTSTRUCT *inCoder, BOOLN *bOOB);

#endif
