/*

	params.h - Parameter routines used by the Power JBIG-2 Encoder


	Author:
		Dave Tompkins (dave.tompkins@ieee.org)
		University of British Columbia

	Source:
		http://spmg.ece.ubc.ca/jbig2
	  
	Revision History:

		1.0.0	1999-03-15	First Release


	Copyright:
		(c) 1998 University of British Columbia and Image Power, Inc.

		The program may be used for academic, demonstration and research 
		purposes only.  It may not be sold for profit or incorporated into
		any commercial programs and/or services without first obtaining a
		commercial useage license from Image Power, Inc.  This program is
		provided as is, without any express or implied warranty, including
		the warranty of fitness for a particular purpose or warranties of
		merchantability.

*/


#ifndef PARAMS_H

#define PARAMS_H

#include "jb2types.h"

typedef struct tagSECTIONPARMS {
	ULONG Page;
	ULONG SectionType;
	ULONG x1,y1,x2,y2;
	ULONG ParmCount;
	char **Parms;
	ULONG *ParmVals;
} SECTIONPARMS;

#define NUMTYPES 3
#define PARMGENREGION 0
#define PARMSYMBREGION 1
#define PARMHALFTONE 2

DLLEXPORT SLONG GetParameterValue(char *, SECTIONPARMS *, SLONG);
DLLEXPORT void ParameterAnalysis(int, char **, SECTIONPARMS *);
DLLEXPORT void FreeParameters(ULONG numParameters,SECTIONPARMS *ParmList);

#endif
